diff -ruNp ejudge-2.3.18/super_html_6.h ejudge/super_html_6.h
--- ejudge-2.3.18/super_html_6.h	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/super_html_6.h	2011-07-11 09:02:04.146280698 +0400
@@ -0,0 +1,163 @@
+/* -*- c -*- */
+/* $Id: super_html_6.h 6339 2011-05-22 07:43:24Z cher $ */
+
+#ifndef __SUPER_HTML_6_H__
+#define __SUPER_HTML_6_H__
+
+/* Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "ej_types.h"
+
+struct ss_op_param_USER_CREATE_ONE_ACTION
+{
+  ej_int_opt_0_t   contest_id;
+  ej_int_opt_0_t   group_id;
+  ej_textbox_t     other_login;
+  ej_textbox_opt_t other_email;
+  ej_checkbox_t    send_email;
+  ej_checkbox_t    confirm_email;
+  ej_textbox_t     reg_password1;
+  ej_textbox_t     reg_password2;
+  ej_checkbox_t    reg_sha1;
+  ej_checkbox_t    field_1;          // USERLIST_NN_IS_PRIVILEGED,
+  ej_checkbox_t    field_2;          // USERLIST_NN_IS_INVISIBLE,
+  ej_checkbox_t    field_3;          // USERLIST_NN_IS_BANNED,
+  ej_checkbox_t    field_4;          // USERLIST_NN_IS_LOCKED,
+  ej_checkbox_t    field_5;          // USERLIST_NN_SHOW_LOGIN,
+  ej_checkbox_t    field_6;          // USERLIST_NN_SHOW_EMAIL,
+  ej_checkbox_t    field_7;          // USERLIST_NN_READ_ONLY,
+  ej_checkbox_t    field_8;          // USERLIST_NN_NEVER_CLEAN,
+  ej_checkbox_t    field_9;          // USERLIST_NN_SIMPLE_REGISTRATION,
+  ej_checkbox_t    reg_cnts_create;
+  ej_int_opt_0_t   other_contest_id_1;
+  ej_int_opt_1_t   cnts_status;
+  ej_checkbox_t    is_invisible;
+  ej_checkbox_t    is_banned;
+  ej_checkbox_t    is_locked;
+  ej_checkbox_t    is_incomplete;
+  ej_checkbox_t    is_disqualified;
+  ej_checkbox_t    cnts_use_reg_passwd;
+  ej_checkbox_t    cnts_null_passwd;
+  ej_textbox_opt_t cnts_password1;
+  ej_textbox_opt_t cnts_password2;
+  ej_checkbox_t    cnts_sha1;
+  ej_textbox_opt_t cnts_name;
+  ej_checkbox_t    group_create;
+  ej_int_opt_0_t   other_group_id;
+};
+
+struct ss_op_param_USER_CREATE_MANY_ACTION
+{
+  ej_int_opt_0_t   contest_id;
+  ej_int_opt_0_t   group_id;
+  ej_int_opt_m1_t  first_serial;
+  ej_int_opt_m1_t  last_serial;
+  ej_textbox_t     login_template;
+  ej_checkbox_t    reg_random;
+  ej_textbox_opt_t reg_password_template;
+  ej_checkbox_t    reg_sha1;
+  ej_checkbox_t    field_1;          // USERLIST_NN_IS_PRIVILEGED,
+  ej_checkbox_t    field_2;          // USERLIST_NN_IS_INVISIBLE,
+  ej_checkbox_t    field_3;          // USERLIST_NN_IS_BANNED,
+  ej_checkbox_t    field_4;          // USERLIST_NN_IS_LOCKED,
+  ej_checkbox_t    field_5;          // USERLIST_NN_SHOW_LOGIN,
+  ej_checkbox_t    field_6;          // USERLIST_NN_SHOW_EMAIL,
+  ej_checkbox_t    field_7;          // USERLIST_NN_READ_ONLY,
+  ej_checkbox_t    field_8;          // USERLIST_NN_NEVER_CLEAN,
+  ej_checkbox_t    field_9;          // USERLIST_NN_SIMPLE_REGISTRATION,
+  ej_checkbox_t    reg_cnts_create;
+  ej_int_opt_0_t   other_contest_id_1;
+  ej_int_opt_1_t   cnts_status;
+  ej_checkbox_t    is_invisible;
+  ej_checkbox_t    is_banned;
+  ej_checkbox_t    is_locked;
+  ej_checkbox_t    is_incomplete;
+  ej_checkbox_t    is_disqualified;
+  ej_checkbox_t    cnts_use_reg_passwd;
+  ej_checkbox_t    cnts_null_passwd;
+  ej_checkbox_t    cnts_random_passwd;
+  ej_textbox_opt_t cnts_password_template;
+  ej_checkbox_t    cnts_sha1;
+  ej_textbox_opt_t cnts_name_template;
+  ej_checkbox_t    group_create;
+  ej_int_opt_0_t   other_group_id;
+};
+
+struct ss_op_param_USER_CREATE_FROM_CSV_ACTION
+{
+  ej_int_opt_0_t   contest_id;
+  ej_int_opt_0_t   group_id;
+  ej_checkbox_t    send_email;
+  ej_checkbox_t    confirm_email;
+  ej_checkbox_t    reg_random;
+  ej_checkbox_t    reg_sha1;
+  ej_checkbox_t    field_1;          // USERLIST_NN_IS_PRIVILEGED,
+  ej_checkbox_t    field_2;          // USERLIST_NN_IS_INVISIBLE,
+  ej_checkbox_t    field_3;          // USERLIST_NN_IS_BANNED,
+  ej_checkbox_t    field_4;          // USERLIST_NN_IS_LOCKED,
+  ej_checkbox_t    field_5;          // USERLIST_NN_SHOW_LOGIN,
+  ej_checkbox_t    field_6;          // USERLIST_NN_SHOW_EMAIL,
+  ej_checkbox_t    field_7;          // USERLIST_NN_READ_ONLY,
+  ej_checkbox_t    field_8;          // USERLIST_NN_NEVER_CLEAN,
+  ej_checkbox_t    field_9;          // USERLIST_NN_SIMPLE_REGISTRATION,
+  ej_checkbox_t    reg_cnts_create;
+  ej_int_opt_0_t   other_contest_id_1;
+  ej_int_opt_1_t   cnts_status;
+  ej_checkbox_t    is_invisible;
+  ej_checkbox_t    is_banned;
+  ej_checkbox_t    is_locked;
+  ej_checkbox_t    is_incomplete;
+  ej_checkbox_t    is_disqualified;
+  ej_checkbox_t    cnts_use_reg_passwd;
+  ej_checkbox_t    cnts_null_passwd;
+  ej_checkbox_t    cnts_random_passwd;
+  ej_checkbox_t    cnts_sha1;
+  ej_textbox_opt_t cnts_name_template;
+  ej_checkbox_t    group_create;
+  ej_int_opt_0_t   other_group_id;
+  ej_textbox_opt_t separator;
+  ej_textbox_opt_t charset;
+};
+
+struct ss_op_param_USER_CREATE_REG_ACTION
+{
+  ej_int_opt_0_t   other_user_id;
+  ej_int_opt_0_t   contest_id;
+  ej_int_opt_0_t   group_id;
+  ej_int_opt_0_t   other_contest_id_1;
+  ej_int_opt_1_t   status;
+  ej_checkbox_t    is_invisible;
+  ej_checkbox_t    is_banned;
+  ej_checkbox_t    is_locked;
+  ej_checkbox_t    is_incomplete;
+  ej_checkbox_t    is_disqualified;
+};
+
+struct ss_op_param_USER_EDIT_REG_ACTION
+{
+  ej_int_opt_0_t   other_user_id;
+  ej_int_opt_0_t   other_contest_id;
+  ej_int_opt_0_t   contest_id;
+  ej_int_opt_0_t   group_id;
+  ej_int_opt_0_t   next_op;
+  ej_int_opt_1_t   status;
+  ej_checkbox_t    is_invisible;
+  ej_checkbox_t    is_banned;
+  ej_checkbox_t    is_locked;
+  ej_checkbox_t    is_incomplete;
+  ej_checkbox_t    is_disqualified;
+};
+
+#endif /* __SUPER_HTML_6_H__ */
diff -ruNp ejudge-2.3.18/super_html.c ejudge/super_html.c
--- ejudge-2.3.18/super_html.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_html.c	2011-07-11 09:02:04.752269556 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: super_html.c 6242 2011-04-10 05:18:38Z cher $ */
+/* $Id: super_html.c 6390 2011-06-30 19:53:38Z cher $ */
 
 /* Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -133,34 +133,6 @@ enum
   MNG_STAT_LAST = MNG_STAT_WAITING,
 };
 static int
-get_serve_management_status(const struct contest_desc *cnts,
-                            struct contest_extra *extra)
-{
-  if (cnts->managed) {
-    return MNG_STAT_NEW_MANAGED;
-  } else if (!cnts->managed && (!extra || !extra->serve_used)) {
-    return MNG_STAT_NOT_MANAGED;
-  } else if (!extra || !extra->serve_used) {
-    return MNG_STAT_TEMP_NOT_MANAGED;
-  } else if (!cnts->managed) {
-    if (extra->serve_suspended) {
-      return MNG_STAT_TEMP_FAILED;
-    } else if (extra->serve_pid > 0) {
-      return MNG_STAT_TEMP_RUNNING;
-    } else {
-      return MNG_STAT_TEMP_WAITING;
-    }
-  } else {
-    if (extra->serve_suspended) {
-      return MNG_STAT_FAILED;
-    } else if (extra->serve_pid > 0) {
-      return MNG_STAT_RUNNING;
-    } else {
-      return MNG_STAT_WAITING;
-    }
-  }
-}
-static int
 get_run_management_status(const struct contest_desc *cnts,
                           struct contest_extra *extra)
 {
@@ -390,6 +362,9 @@ super_html_main_page(FILE *f,
 
   fprintf(f, "<table border=\"0\"><tr><td>%sProblem editor</a></td></tr></table>\n", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d&op=%d", SSERV_CMD_HTTP_REQUEST, SSERV_OP_BROWSE_PROBLEM_PACKAGES));
 
+  fprintf(f, "<table border=\"0\"><tr><td>%sUser editor</a></td></tr></table>\n", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d&op=%d", SSERV_CMD_HTTP_REQUEST, SSERV_OP_USER_BROWSE_PAGE));
+  fprintf(f, "<table border=\"0\"><tr><td>%sGroup editor</a></td></tr></table>\n", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d&op=%d", SSERV_CMD_HTTP_REQUEST, SSERV_OP_GROUP_BROWSE_PAGE));
+
   fprintf(f, "<table border=\"0\"><tr><td>%sCreate new contest</a></td>", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d", SSERV_CMD_CREATE_CONTEST));
   if (sstate->edited_cnts) {
     fprintf(f, "<td>%sEdit current contest</a></td>",
@@ -423,9 +398,11 @@ super_html_main_page(FILE *f,
           "<th>Name</th>\n"
           "<th>Closed?</th>\n"
           "<th>Run status</th>\n"
+          "<th>Users</th>\n"
           "<th>Judge</th>\n"
           "<th>Master</th>\n"
           "<th>User</th>\n"
+          "<th>Edit</th>\n"
           "<th>Details</th>\n"
           "</tr>\n");
   for (contest_id = 1; contest_id < contest_max_id; contest_id++) {
@@ -586,6 +563,8 @@ super_html_main_page(FILE *f,
       fprintf(f, "<td>&nbsp;</td>\n");
     }
 
+    fprintf(f, "<td>%sUsers</a></td>\n", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d&op=%d&contest_id=%d", SSERV_CMD_HTTP_REQUEST, SSERV_OP_USER_BROWSE_PAGE, contest_id));
+
     // report judge URL
     if (opcaps_check(caps, OPCAP_JUDGE_LOGIN) >= 0 && judge_url[0]
         && contests_check_judge_ip_2(cnts, ip_address, ssl)) {
@@ -628,6 +607,10 @@ super_html_main_page(FILE *f,
     if (priv_level >= PRIV_LEVEL_ADMIN
         && opcaps_check(caps, OPCAP_CONTROL_CONTEST) >= 0
         && contests_check_serve_control_ip_2(cnts, ip_address, ssl)) {
+      fprintf(f, "<td>%sEdit</a></td>",
+              html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args,
+                            "contest_id=%d&action=%d", contest_id,
+                            SSERV_CMD_EDIT_CONTEST_XML));
       fprintf(f, "<td>%sDetails</a></td>\n",
               html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args,
                             "contest_id=%d&action=%d", contest_id,
@@ -783,6 +766,8 @@ super_html_contest_page(FILE *f,
     fprintf(f, "<tr><td>Contest keywords:</td><td><tt>%s</tt></td></tr>\n", cnts->keywords);
   }
 
+  fprintf(f, "<tr><td>View/edit users</td><td>%sUsers</a></td></tr>\n", html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args, "action=%d&op=%d&contest_id=%d", SSERV_CMD_HTTP_REQUEST, SSERV_OP_USER_BROWSE_PAGE, contest_id));
+
   // report judge URL
   if (opcaps_check(caps, OPCAP_JUDGE_LOGIN) >= 0 && judge_url[0]
       && contests_check_judge_ip_2(cnts, ip_address, ssl)) {
@@ -850,149 +835,6 @@ super_html_contest_page(FILE *f,
   }
   fprintf(f, "</tr>\n");
 
-  // report serve status
-  mng_status = get_serve_management_status(cnts, extra);
-  snprintf(mng_status_str, sizeof(mng_status_str),
-           mng_status_table[mng_status], extra?extra->serve_pid:0);
-  fprintf(f, "<tr><td><tt>serve</tt> management status:</td><td>%s</td>",
-          mng_status_str);
-  if (opcaps_check(caps, OPCAP_CONTROL_CONTEST) >= 0) {
-    fprintf(f, "<td>");
-    html_start_form(f, 1, self_url, new_hidden_vars);
-    switch (mng_status) {
-    case MNG_STAT_NOT_MANAGED:
-    case MNG_STAT_NEW_MANAGED:
-      fprintf(f, "&nbsp;");
-      /* FIXME: disabled for now
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_TEMP,
-                         "Manage temporarily");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG, "Manage permanently");
-      */
-      break;
-    case MNG_STAT_TEMP_NOT_MANAGED:
-      fprintf(f, "&nbsp;");
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_RESUME,
-                         "Resume management");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      break;
-    case MNG_STAT_TEMP_FAILED:
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG, "Manage permanently");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_RESET_ERROR,
-                         "Reset error flag");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_PROBE_RUN,
-                         "Do probe run");
-      break;
-    case MNG_STAT_TEMP_RUNNING:
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG, "Manage permanently");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_TERM, "Terminate serve");
-      break;
-    case MNG_STAT_TEMP_WAITING:
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG, "Manage permanently");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_PROBE_RUN,
-                         "Do probe run");
-      break;
-    case MNG_STAT_FAILED:
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_SUSPEND,
-                         "Suspend management");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_RESET_ERROR,
-                         "Reset error flag");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_PROBE_RUN,
-                         "Do probe run");
-      break;
-    case MNG_STAT_RUNNING:
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_SUSPEND,
-                         "Suspend management");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP, "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_TERM, "Terminate serve");
-      break;
-    case MNG_STAT_WAITING:
-      fprintf(f, "&nbsp;");
-      /*
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_SUSPEND,
-                         "Suspend management");
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_STOP,
-                         "Stop management");
-      */
-      html_submit_button(f, SSERV_CMD_SERVE_MNG_PROBE_RUN,
-                         "Do probe run");
-      break;
-    default:
-      abort();
-    }
-    fprintf(f, "</form>");
-    fprintf(f, "</td>");
-  }
-
-  // whether /dev/null exists?
-  if (stat("/dev/null", &devnullstat) < 0) {
-    // :( how come???
-    nodevnull = 1;
-  }
-
-  // serve log file status
-  if (!cnts->root_dir) {
-    logfilemode = 3;
-    snprintf(mng_status_str, sizeof(mng_status_str), "N/A");
-  } else {
-    snprintf(log_file_path, sizeof(log_file_path),
-             "%s/var/messages", cnts->root_dir);
-    if (stat(log_file_path, &logfilestat) < 0) {
-      logfilemode = 0;
-      snprintf(mng_status_str, sizeof(mng_status_str), "nonexistant");
-    } else if (!nodevnull
-               && logfilestat.st_dev == devnullstat.st_dev
-               && logfilestat.st_ino == devnullstat.st_ino) {
-      logfilemode = 1;
-      snprintf(mng_status_str, sizeof(mng_status_str), "/dev/null");
-    } else {
-      logfilemode = 2;
-      snprintf(mng_status_str, sizeof(mng_status_str), "%lld bytes",
-               (long long) logfilestat.st_size);
-    }
-  }
-
-  fprintf(f, "<tr><td>Serve log:</td><td>%s</td>", mng_status_str);
-  if (opcaps_check(caps, OPCAP_CONTROL_CONTEST) >= 0
-      && logfilemode != 3) {
-    fprintf(f, "<td>");
-    html_start_form(f, 1, self_url, new_hidden_vars);
-    if (logfilemode == 0) {
-      html_submit_button(f, SSERV_CMD_SERVE_LOG_DEV_NULL,
-                         "Redirect to /dev/null");
-    } else if (logfilemode == 2) {
-      html_submit_button(f, SSERV_CMD_SERVE_LOG_TRUNC, "Truncate log");
-      html_submit_button(f, SSERV_CMD_SERVE_LOG_DEV_NULL,
-                         "Redirect to /dev/null");
-      if (logfilestat.st_size <= MAX_LOG_VIEW_SIZE) {
-        fprintf(f, "%sView</a>",
-                html_hyperref(hbuf, sizeof(hbuf), session_id, self_url, extra_args,
-                              "contest_id=%d&action=%d", contest_id,
-                              SSERV_CMD_VIEW_SERVE_LOG));
-      }
-    } else if (logfilemode == 1) {
-      html_submit_button(f, SSERV_CMD_SERVE_LOG_FILE, "Redirect to file");
-    }
-    fprintf(f, "</form>");
-    fprintf(f, "</td>");
-  }
-  fprintf(f, "</tr>\n");
-
   // report run status
   mng_status = get_run_management_status(cnts, extra);
   snprintf(mng_status_str, sizeof(mng_status_str),
@@ -1092,7 +934,7 @@ super_html_contest_page(FILE *f,
     snprintf(mng_status_str, sizeof(mng_status_str), "N/A");
   } else {
     snprintf(log_file_path, sizeof(log_file_path),
-             "%s/var/run_messages", cnts->root_dir);
+             "%s/var/ej-run-messages.log", cnts->root_dir);
     if (stat(log_file_path, &logfilestat) < 0) {
       logfilemode = 0;
       snprintf(mng_status_str, sizeof(mng_status_str), "nonexistant");
@@ -1299,7 +1141,7 @@ super_html_log_page(FILE *f,
     break;
   case SSERV_CMD_VIEW_RUN_LOG:
     snprintf(log_file_path, sizeof(log_file_path),
-             "%s/var/run_messages", cnts->root_dir);
+             "%s/var/ej-run-messages.log", cnts->root_dir);
     progname = "run";
     refresh_action = SSERV_CMD_VIEW_RUN_LOG;
     break;
@@ -2461,6 +2303,26 @@ super_html_edit_contest_page(FILE *f,
                            self_url,
                            extra_args,
                            hidden_vars);
+  print_string_editing_row(f, "URL for the contest logo:",
+                           cnts->logo_url,
+                           SSERV_CMD_CNTS_CHANGE_LOGO_URL,
+                           SSERV_CMD_CNTS_CLEAR_LOGO_URL,
+                           0,
+                           session_id,
+                           form_row_attrs[row ^= 1],
+                           self_url,
+                           extra_args,
+                           hidden_vars);
+  print_string_editing_row(f, "URL for the contest CSS:",
+                           cnts->css_url,
+                           SSERV_CMD_CNTS_CHANGE_CSS_URL,
+                           SSERV_CMD_CNTS_CLEAR_CSS_URL,
+                           0,
+                           session_id,
+                           form_row_attrs[row ^= 1],
+                           self_url,
+                           extra_args,
+                           hidden_vars);
 
   html_start_form(f, 1, self_url, hidden_vars);
   fprintf(f, "<tr%s><td colspan=\"4\" align=\"center\"><b>Various contest's flags</b>", head_row_attr);
diff -ruNp ejudge-2.3.18/super_html.h ejudge/super_html.h
--- ejudge-2.3.18/super_html.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_html.h	2011-07-11 09:02:04.769269244 +0400
@@ -1,9 +1,9 @@
 /* -*- c -*- */
-/* $Id: super_html.h 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: super_html.h 6379 2011-06-24 18:47:55Z cher $ */
 #ifndef __SUPER_HTML_H__
 #define __SUPER_HTML_H__
 
-/* Copyright (C) 2004-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -484,6 +484,34 @@ enum
   S_ERR_INV_PACKAGE,
   S_ERR_ITEM_EXISTS,
   S_ERR_OPERATION_FAILED,
+  S_ERR_INV_USER_ID,
+  S_ERR_NO_CONNECTION,
+  S_ERR_DB_ERROR,
+  S_ERR_UNSPEC_PASSWD1,
+  S_ERR_UNSPEC_PASSWD2,
+  S_ERR_INV_PASSWD1,
+  S_ERR_INV_PASSWD2,
+  S_ERR_PASSWDS_DIFFER,
+  S_ERR_UNSPEC_LOGIN,
+  S_ERR_DUPLICATED_LOGIN,
+  S_ERR_INV_GROUP_ID,
+  S_ERR_INV_FIRST_SERIAL,
+  S_ERR_INV_LAST_SERIAL,
+  S_ERR_INV_RANGE,
+  S_ERR_INV_LOGIN_TEMPLATE,
+  S_ERR_INV_REG_PASSWORD_TEMPLATE,
+  S_ERR_INV_CNTS_PASSWORD_TEMPLATE,
+  S_ERR_INV_CNTS_NAME_TEMPLATE,
+  S_ERR_INV_CSV_FILE,
+  S_ERR_INV_CHARSET,
+  S_ERR_INV_SEPARATOR,
+  S_ERR_DATA_READ_ONLY,
+  S_ERR_TOO_MANY_MEMBERS,
+  S_ERR_INV_SERIAL,
+  S_ERR_INV_EMAIL,
+  S_ERR_INV_GROUP_NAME,
+  S_ERR_INV_DESCRIPTION,
+  S_ERR_GROUP_CREATION_FAILED,
 
   S_ERR_LAST
 };
@@ -493,6 +521,17 @@ ss_cgi_param(
         const struct super_http_request_info *phr,
         const unsigned char *param,
         const unsigned char **p_value);
+int
+ss_cgi_param_int(
+        struct super_http_request_info *phr,
+        const unsigned char *name,
+        int *p_val);
+int
+ss_cgi_param_int_opt(
+        struct super_http_request_info *phr,
+        const unsigned char *name,
+        int *p_val,
+        int default_value);
 
 void
 ss_write_html_header(
diff -ruNp ejudge-2.3.18/super_proto.h ejudge/super_proto.h
--- ejudge-2.3.18/super_proto.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_proto.h	2011-07-11 09:02:04.520273822 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: super_proto.h 6214 2011-04-01 20:03:14Z cher $ */
+/* $Id: super_proto.h 6379 2011-06-24 18:47:55Z cher $ */
 
 #ifndef __SUPER_PROTO_H__
 #define __SUPER_PROTO_H__
@@ -165,6 +165,8 @@ enum
   SSERV_CMD_CNTS_CLEAR_TEAM_URL,
   SSERV_CMD_CNTS_CLEAR_STANDINGS_URL,
   SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL,
+  SSERV_CMD_CNTS_CLEAR_LOGO_URL,
+  SSERV_CMD_CNTS_CLEAR_CSS_URL,
   SSERV_CMD_CNTS_CLEAR_ROOT_DIR,
   SSERV_CMD_CNTS_CLEAR_CONF_DIR,
 
@@ -237,6 +239,8 @@ enum
   SSERV_CMD_CNTS_CHANGE_TEAM_URL,
   SSERV_CMD_CNTS_CHANGE_STANDINGS_URL,
   SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL,
+  SSERV_CMD_CNTS_CHANGE_LOGO_URL,
+  SSERV_CMD_CNTS_CHANGE_CSS_URL,
   SSERV_CMD_CNTS_CHANGE_ROOT_DIR,
   SSERV_CMD_CNTS_CHANGE_CONF_DIR,
   SSERV_CMD_CNTS_CHANGE_DIR_MODE,
@@ -828,6 +832,88 @@ enum
   SSERV_OP_DELETE_ITEM,
   SSERV_OP_EDIT_PROBLEM,
 
+  SSERV_OP_USER_BROWSE_PAGE,                   /* OK */
+  SSERV_OP_USER_FILTER_CHANGE_ACTION,          /* OK */
+  SSERV_OP_USER_FILTER_FIRST_PAGE_ACTION,      /* OK */
+  SSERV_OP_USER_FILTER_PREV_PAGE_ACTION,       /* OK */
+  SSERV_OP_USER_FILTER_NEXT_PAGE_ACTION,       /* OK */
+  SSERV_OP_USER_FILTER_LAST_PAGE_ACTION,       /* OK */
+  SSERV_OP_USER_JUMP_CONTEST_ACTION,
+  SSERV_OP_USER_JUMP_GROUP_ACTION,
+  SSERV_OP_USER_BROWSE_MARK_ALL_ACTION,
+  SSERV_OP_USER_BROWSE_UNMARK_ALL_ACTION,
+  SSERV_OP_USER_BROWSE_TOGGLE_ALL_ACTION,
+  SSERV_OP_USER_CREATE_ONE_PAGE,               /* OK */
+  SSERV_OP_USER_CREATE_ONE_ACTION,             /* OK */
+  SSERV_OP_USER_CREATE_MANY_PAGE,              /* OK */
+  SSERV_OP_USER_CREATE_MANY_ACTION,            /* OK */
+  SSERV_OP_USER_CREATE_FROM_CSV_PAGE,          /* OK */
+  SSERV_OP_USER_CREATE_FROM_CSV_ACTION,        /* OK */
+  SSERV_OP_USER_DETAIL_PAGE,                   /* OK */
+  SSERV_OP_USER_PASSWORD_PAGE,                 /* OK */
+  SSERV_OP_USER_CHANGE_PASSWORD_ACTION,        /* OK */
+  SSERV_OP_USER_CNTS_PASSWORD_PAGE,            /* OK */
+  SSERV_OP_USER_CHANGE_CNTS_PASSWORD_ACTION,   /* OK */
+  SSERV_OP_USER_CLEAR_FIELD_ACTION,
+  SSERV_OP_USER_CREATE_MEMBER_ACTION,          /* OK */
+  SSERV_OP_USER_DELETE_MEMBER_PAGE,            /* OK */
+  SSERV_OP_USER_DELETE_MEMBER_ACTION,          /* OK */
+  SSERV_OP_USER_SAVE_AND_PREV_ACTION,          /* OK */
+  SSERV_OP_USER_SAVE_ACTION,                   /* OK */
+  SSERV_OP_USER_SAVE_AND_NEXT_ACTION,          /* OK */
+  SSERV_OP_USER_CANCEL_AND_PREV_ACTION,        /* OK */
+  SSERV_OP_USER_CANCEL_ACTION,                 /* OK */
+  SSERV_OP_USER_CANCEL_AND_NEXT_ACTION,        /* OK */
+  SSERV_OP_USER_CREATE_REG_PAGE,               /* OK */
+  SSERV_OP_USER_CREATE_REG_ACTION,             /* OK */
+  SSERV_OP_USER_EDIT_REG_PAGE,                 /* OK */
+  SSERV_OP_USER_EDIT_REG_ACTION,               /* OK */
+  SSERV_OP_USER_DELETE_REG_PAGE,               /* OK */
+  SSERV_OP_USER_DELETE_REG_ACTION,             /* OK */
+  SSERV_OP_USER_DELETE_SESSION_ACTION,
+  SSERV_OP_USER_DELETE_ALL_SESSIONS_ACTION,
+  SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_PAGE,
+  SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_ACTION,
+  SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_PAGE,
+  SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_ACTION,
+  SSERV_OP_USER_SEL_CREATE_REG_PAGE,
+  SSERV_OP_USER_SEL_CREATE_REG_ACTION,
+  SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_PAGE,
+  SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_ACTION,
+  SSERV_OP_USER_SEL_DELETE_REG_PAGE,
+  SSERV_OP_USER_SEL_DELETE_REG_ACTION,
+  SSERV_OP_USER_SEL_CHANGE_REG_STATUS_PAGE,
+  SSERV_OP_USER_SEL_CHANGE_REG_STATUS_ACTION,
+  SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_PAGE,
+  SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_ACTION,
+  SSERV_OP_USER_SEL_CANCEL_ACTION,
+  SSERV_OP_USER_SEL_VIEW_PASSWD_PAGE,
+  SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_PAGE,
+  SSERV_OP_USER_SEL_VIEW_PASSWD_REDIRECT,
+  SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_REDIRECT,
+  SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_PAGE,
+  SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_ACTION,
+  SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_PAGE,
+  SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_ACTION,
+
+  SSERV_OP_GROUP_BROWSE_PAGE,
+  SSERV_OP_GROUP_FILTER_CHANGE_ACTION,
+  SSERV_OP_GROUP_FILTER_FIRST_PAGE_ACTION,
+  SSERV_OP_GROUP_FILTER_PREV_PAGE_ACTION,
+  SSERV_OP_GROUP_FILTER_NEXT_PAGE_ACTION,
+  SSERV_OP_GROUP_FILTER_LAST_PAGE_ACTION,
+  SSERV_OP_GROUP_CREATE_PAGE,
+  SSERV_OP_GROUP_CREATE_ACTION,
+  SSERV_OP_GROUP_MODIFY_PAGE,
+  SSERV_OP_GROUP_MODIFY_PAGE_ACTION,
+  SSERV_OP_GROUP_MODIFY_ACTION,
+  SSERV_OP_GROUP_DELETE_PAGE,
+  SSERV_OP_GROUP_DELETE_PAGE_ACTION,
+  SSERV_OP_GROUP_DELETE_ACTION,
+  SSERV_OP_GROUP_CANCEL_ACTION,
+
   SSERV_OP_LAST,
 };
 
diff -ruNp ejudge-2.3.18/super-serve.c ejudge/super-serve.c
--- ejudge-2.3.18/super-serve.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super-serve.c	2011-07-11 09:02:04.418275697 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: super-serve.c 6214 2011-04-01 20:03:14Z cher $ */
+/* $Id: super-serve.c 6359 2011-06-10 20:04:28Z cher $ */
 
 /* Copyright (C) 2003-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -466,7 +466,7 @@ prepare_run_serving(const struct contest
     return;
   }
 
-  snprintf(run_log_path, sizeof(run_log_path), "%s/run_messages",
+  snprintf(run_log_path, sizeof(run_log_path), "%s/ej-run-messages.log",
            extra->var_dir);
 
   if ((queue_dir_fd = open(run_queue_dir, O_RDONLY, 0)) < 0) {
@@ -1627,6 +1627,8 @@ sid_state_clear(struct sid_state *p)
   super_serve_clear_edited_contest(p);
   xfree(p->user_login);
   xfree(p->user_name);
+  xfree(p->user_filter);
+  bitset_free(&p->marked);
   XMEMZERO(p, 1);
 }
 static struct sid_state*
@@ -2640,6 +2642,8 @@ cmd_simple_top_command(struct client_sta
   case SSERV_CMD_CNTS_CLEAR_TEAM_URL:
   case SSERV_CMD_CNTS_CLEAR_STANDINGS_URL:
   case SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL:
+  case SSERV_CMD_CNTS_CLEAR_LOGO_URL:
+  case SSERV_CMD_CNTS_CLEAR_CSS_URL:
   case SSERV_CMD_CNTS_CLEAR_ROOT_DIR:
   case SSERV_CMD_CNTS_CLEAR_CONF_DIR:
   case SSERV_CMD_CNTS_CLEAR_DIR_MODE:
@@ -2774,6 +2778,8 @@ cmd_set_value(struct client_state *p, in
   case SSERV_CMD_CNTS_CHANGE_TEAM_URL:
   case SSERV_CMD_CNTS_CHANGE_STANDINGS_URL:
   case SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL:
+  case SSERV_CMD_CNTS_CHANGE_LOGO_URL:
+  case SSERV_CMD_CNTS_CHANGE_CSS_URL:
   case SSERV_CMD_CNTS_CHANGE_ROOT_DIR:
   case SSERV_CMD_CNTS_CHANGE_CONF_DIR:
   case SSERV_CMD_CNTS_CHANGE_DIR_MODE:
@@ -3483,6 +3489,7 @@ cmd_http_request(
   hr.ip = p->ip;
   hr.ssl_flag = p->ssl;
   hr.system_login = userlist_login;
+  hr.userlist_clnt = userlist_clnt;
 
   hr.ss = sid_state_get(p->cookie, p->user_id, p->login, p->name);
   hr.config = config;
@@ -3633,6 +3640,8 @@ static const struct packet_handler packe
   [SSERV_CMD_CNTS_CLEAR_TEAM_URL] = { cmd_simple_top_command },
   [SSERV_CMD_CNTS_CLEAR_STANDINGS_URL] = { cmd_simple_top_command },
   [SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL] = { cmd_simple_top_command },
+  [SSERV_CMD_CNTS_CLEAR_LOGO_URL] = { cmd_simple_top_command },
+  [SSERV_CMD_CNTS_CLEAR_CSS_URL] = { cmd_simple_top_command },
   [SSERV_CMD_CNTS_CLEAR_ROOT_DIR] = { cmd_simple_top_command },
   [SSERV_CMD_CNTS_CLEAR_CONF_DIR] = { cmd_simple_top_command },
   [SSERV_CMD_CNTS_CLEAR_DIR_MODE] = { cmd_simple_top_command },
@@ -3708,6 +3717,8 @@ static const struct packet_handler packe
   [SSERV_CMD_CNTS_CHANGE_TEAM_URL] = { cmd_set_value },
   [SSERV_CMD_CNTS_CHANGE_STANDINGS_URL] = { cmd_set_value },
   [SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL] = { cmd_set_value },
+  [SSERV_CMD_CNTS_CHANGE_LOGO_URL] = { cmd_set_value },
+  [SSERV_CMD_CNTS_CHANGE_CSS_URL] = { cmd_set_value },
   [SSERV_CMD_CNTS_CHANGE_ROOT_DIR] = { cmd_set_value },
   [SSERV_CMD_CNTS_CHANGE_CONF_DIR] = { cmd_set_value },
   [SSERV_CMD_CNTS_CHANGE_DIR_MODE] = { cmd_set_value },
@@ -3883,6 +3894,8 @@ static const struct packet_handler packe
   [SSERV_CMD_PROB_CHANGE_MAX_STACK_SIZE] = { cmd_set_value },
   [SSERV_CMD_PROB_CHANGE_MAX_CORE_SIZE] = { cmd_set_value },
   [SSERV_CMD_PROB_CHANGE_MAX_FILE_SIZE] = { cmd_set_value },
+  [SSERV_CMD_PROB_CHANGE_MAX_OPEN_FILE_COUNT] = { cmd_set_value },
+  [SSERV_CMD_PROB_CHANGE_MAX_PROCESS_COUNT] = { cmd_set_value },
   [SSERV_CMD_PROB_CHANGE_INPUT_FILE] = { cmd_set_value },
   [SSERV_CMD_PROB_CLEAR_INPUT_FILE] = { cmd_set_value },
   [SSERV_CMD_PROB_CHANGE_OUTPUT_FILE] = { cmd_set_value },
@@ -4263,7 +4276,7 @@ contest_mngmt_cmd(const struct contest_d
     snprintf(log_path, sizeof(log_path), "%s/var/messages", cnts->root_dir);
     goto do_truncate_log;
   case SSERV_CMD_RUN_LOG_TRUNC:
-    snprintf(log_path, sizeof(log_path), "%s/var/run_messages", cnts->root_dir);
+    snprintf(log_path, sizeof(log_path), "%s/var/ej-run-messages.log", cnts->root_dir);
     goto do_truncate_log;
 
   do_truncate_log:
@@ -4277,7 +4290,7 @@ contest_mngmt_cmd(const struct contest_d
     snprintf(log_path, sizeof(log_path), "%s/var/messages", cnts->root_dir);
     goto do_dev_null;
   case SSERV_CMD_RUN_LOG_DEV_NULL:
-    snprintf(log_path, sizeof(log_path), "%s/var/run_messages", cnts->root_dir);
+    snprintf(log_path, sizeof(log_path), "%s/var/ej-run-messages.log", cnts->root_dir);
     goto do_dev_null;
 
   do_dev_null:
@@ -4295,7 +4308,7 @@ contest_mngmt_cmd(const struct contest_d
     snprintf(log_path, sizeof(log_path), "%s/var/messages", cnts->root_dir);
     goto do_file;
   case SSERV_CMD_RUN_LOG_FILE:
-    snprintf(log_path, sizeof(log_path), "%s/var/run_messages", cnts->root_dir);
+    snprintf(log_path, sizeof(log_path), "%s/var/ej-run-messages.log", cnts->root_dir);
     goto do_file;
 
   do_file:
